'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _weakMap = require('babel-runtime/core-js/weak-map');

var _weakMap2 = _interopRequireDefault(_weakMap);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var privateModel = new _weakMap2.default();

var FieldModelPublic = function () {
  function FieldModelPublic(model) {
    var _this = this;

    (0, _classCallCheck3.default)(this, FieldModelPublic);

    this.setValue = function () {
      return _this.__setValue__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.errors = function () {
      return _this.__errors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isValid = function () {
      return _this.__isValid__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isExcluded = function () {
      return _this.__isExcluded__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.validate = function () {
      return _this.__validate__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reload = function () {
      return _this.__reload__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    privateModel.set(this, model);
    this.name = (0, _lodash.cloneDeep)(model.name);
  }

  FieldModelPublic.prototype.__setValue__REACT_HOT_LOADER__ = function __setValue__REACT_HOT_LOADER__(value) {
    var model = privateModel.get(this);
    return model.setValue(value);
  };

  FieldModelPublic.prototype.__errors__REACT_HOT_LOADER__ = function __errors__REACT_HOT_LOADER__() {
    var model = privateModel.get(this);
    return model.getErrors();
  };

  FieldModelPublic.prototype.__isValid__REACT_HOT_LOADER__ = function __isValid__REACT_HOT_LOADER__() {
    var model = privateModel.get(this);
    return model.isValid();
  };

  FieldModelPublic.prototype.__isExcluded__REACT_HOT_LOADER__ = function __isExcluded__REACT_HOT_LOADER__() {
    var model = privateModel.get(this);
    return model.isExcluded();
  };

  FieldModelPublic.prototype.__validate__REACT_HOT_LOADER__ = function __validate__REACT_HOT_LOADER__() {
    var model = privateModel.get(this);
    return model.validate();
  };

  FieldModelPublic.prototype.__reload__REACT_HOT_LOADER__ = function __reload__REACT_HOT_LOADER__() {
    var model = privateModel.get(this);
    return model.reload();
  };

  (0, _createClass3.default)(FieldModelPublic, [{
    key: 'value',
    get: function get() {
      var model = privateModel.get(this);
      return (0, _lodash.cloneDeep)(model.value);
    }
  }, {
    key: 'focused',
    get: function get() {
      var model = privateModel.get(this);
      return (0, _lodash.cloneDeep)(model.focused);
    }
  }, {
    key: 'touched',
    get: function get() {
      var model = privateModel.get(this);
      return (0, _lodash.cloneDeep)(model.touched);
    }
  }, {
    key: 'dirty',
    get: function get() {
      var model = privateModel.get(this);
      return (0, _lodash.cloneDeep)(model.dirty);
    }
  }, {
    key: 'submitted',
    get: function get() {
      var model = privateModel.get(this);
      return (0, _lodash.cloneDeep)(model.submitted);
    }
  }]);
  return FieldModelPublic;
}();

var _default = FieldModelPublic;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(privateModel, 'privateModel', '/Users/flamps/Documents/React/github/Flamps/vb-react-form/src/FormsV1/Form/public/FieldModelPublic.js');

  __REACT_HOT_LOADER__.register(FieldModelPublic, 'FieldModelPublic', '/Users/flamps/Documents/React/github/Flamps/vb-react-form/src/FormsV1/Form/public/FieldModelPublic.js');

  __REACT_HOT_LOADER__.register(_default, 'default', '/Users/flamps/Documents/React/github/Flamps/vb-react-form/src/FormsV1/Form/public/FieldModelPublic.js');
}();

;